#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>

#define FOR(i, m, n) for (int i=m; i<n; i++)

using namespace std;

struct Hrana {
  int v;
  int km;
};

struct D {
  int v;
  int cel;
  long long km;
  // Pozor, oprátor vypadá takto nepřirozeně kvůli haldě z STL
  bool operator<(const D &d) const {
    return (cel>d.cel || (cel==d.cel && km>d.km));
  }
};

int N, M, C, X, Y;
vector<Hrana> graf[11000];
bool celnice[11000];
bool otevreny[11000];
D d[11000];
vector<D> halda;

int main()
{
  FILE *fr, *fw;
  fr = fopen("vstup.in", "r");
  fw = fopen("vystup.out", "w");
  //fr = stdin; fw = stdout;
  
  // Načtení vstupu
  fscanf(fr, "%d%d%d%d%d", &N, &M, &C, &X, &Y);
  FOR (i, 0, C) {
    int x; fscanf(fr, "%d", &x);
    celnice[x] = true;
  }
  FOR (i, 0, M) {
    int x, y, z; fscanf(fr, "%d%d%d", &x, &y, &z);
    graf[x].push_back((Hrana){y, z});
    graf[y].push_back((Hrana){x, z});
  }
  
  // Inicializace
  FOR (i, 1, N+1) {
    d[i] = (D){i, INT_MAX, INT_MAX};
    otevreny[i] = true;
  }
  d[X] = (D){X, 0, 0};
  halda.push_back(d[X]); push_heap(halda.begin(), halda.end());
  
  // Dijkstrův algoritmus
  while (otevreny[Y] && !halda.empty()) {
    // Výběr nejmenšího otevřeného prvku
    D akt; bool vybrano = false;
    do {
      akt = halda[0]; pop_heap(halda.begin(), halda.end()); halda.pop_back();
      if (otevreny[akt.v]) vybrano = true;
    } while (!otevreny[akt.v] && !halda.empty());
    if (!vybrano) break;
    int v = akt.v; otevreny[v] = false;
    if (!otevreny[Y]) break;
    // Přepočítání vzdáleností
    FOR (i, 0, graf[v].size()) {
      int u = graf[v][i].v;
      D nova; nova.v = u;
      nova.km = d[v].km + graf[v][i].km;
      nova.cel = d[v].cel + celnice[u];
      if (u == Y && celnice[u])
	nova.cel--;
      if (nova.cel<d[u].cel || (nova.cel == d[u].cel && nova.km < d[u].km)) {
	d[u] = nova;
	halda.push_back(d[u]); push_heap(halda.begin(), halda.end());
      }
    }
  }
  
  fprintf(fw, "%d %lld\n", d[Y].cel, d[Y].km);
  
  fclose(fr);
  fclose(fw);
  return 0;
}
