#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>

#define FOR(i, m, n) for (int i=m; i<n; i++)

using namespace std;

struct Trie {
  int pocet;
  map<char, Trie*> dalsi;
};

Trie* trie_novy_vrchol() {
  Trie *t = new Trie;
  t->pocet = 0;
  return t;
}

void trie_add(Trie *trie, int n, char slovo[]) {
  int i=0; Trie *t = trie;
  while (i<n) {
    if (t->dalsi.find(slovo[i]-'a')==t->dalsi.end())
      t->dalsi[slovo[i]-'a'] = trie_novy_vrchol();
    t = t->dalsi[slovo[i]-'a'];
    i++;
  }
  t->pocet = t->pocet + 1;
}

int trie_get(Trie *trie, int n, char slovo[]) {
  int i=0; Trie *t = trie;
  while (i<n) {
    if (t->dalsi.find(slovo[i]-'a')==t->dalsi.end())
      return 0;
    t = t->dalsi[slovo[i]-'a'];
    i++;
  }
  return t->pocet;
}

// Lexikograficky nejmenší rotace retězce
// Funkce je napsána takto děsně, protože je skopírována z letáčku, kde sloužila jako úloha.
int flr(int n, char a[]) {
  #define A(i) a[((i) + k) % n]
  int l[n], ls = n, z[n], min = 0;
  for (int i = 0; i < n; i++) l[i] = i, z[i] = 1;
  for (int k = 0; ls >= 2; k++) {
    min = l[0]; for (int i=0; i<ls; i++) min = A(l[i])<A(min) ? l[i] : min;
    for (int i=0; i<ls; i++) z[A(l[i])!=A(min) ? l[i] : (l[i]+k+1)%n] = 0;
    for (int ls_=ls, i=ls=0; i<ls_; i++) if (z[l[i]]) l[ls++] = l[i];
  }
  return ls == 1 ? l[0] : min;
}

Trie *trie;
int N;
char slovo[11000];
char *min_rot[11000]; int delka[11000];

int main()
{
  FILE *fr, *fw;
  fr = fopen("vstup.in", "r");
  fw = fopen("vystup.out", "w");
  //fr = stdin; fw = stdout;
  
  // inicializace trie
  trie = trie_novy_vrchol();
  fscanf(fr, "%d", &N);
  FOR (i, 0, N) {
    // Načti slovo a nalezni jeho lexikograficky nejmenší rotaci
    fscanf(fr, " %s", slovo);
    int m = strlen(slovo);
    int x = flr(m, slovo);
    min_rot[i] = new char[m+1]; delka[i] = m;
    FOR (j, 0, m) {
      min_rot[i][j] = slovo[(x+j)%m];
    }
    min_rot[i][m] = '\0';
    // Pricteni slova do trie
    trie_add(trie, m, min_rot[i]);
  }
  // Vypsání výsledků
  FOR (i, 0, N) {
    fprintf(fw, "%d\n", trie_get(trie, delka[i], min_rot[i]));
  }
  
  fclose(fr);
  fclose(fw);
  return 0;
}
