#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cctype>
#include <cstring>
#include <string>
#include <climits>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <list>
#include <ctime>

#define FOR(i, m, n) for (int i=m; i<n; i++)

using namespace std;

#define MAX 1000

struct Bod {
  int x;
  int y;
};

Bod smer[8] = {{2, 1}, {1, 2}, {2, -1}, {-1, 2}, {-2, 1}, {1, -2}, {-2, -1}, {-1, -2}};
Bod kun[5];
Bod cil[5];
int D[5][5];		// Vzdálenosti koňů od cílů
int skoky[600][600];
int N;
int ret = INT_MAX;
int perm[5];

// Vyykoušení všech permutací
void zkus_perm(int k) {
  if (k==5) {
    int d = 0;
    FOR (i, 0, 5) {
      d += D[i][perm[i]];
    }
    ret = min(ret, d);
  }
  else {
    FOR (i, 0, 5) {
      bool b = true;
      FOR (j, 0, k) {
	if (perm[j]==i)
	  b = false;
      }
      if (b) {
	perm[k] = i;
	zkus_perm(k+1);
      }
    }
  }
}

int main()
{
  FILE *fr, *fw;
  fr = fopen("vstup.in", "r");
  fw = fopen("vystup.out", "w");
  //fr = stdin; fw = stdout;
  
  fscanf(fr, "%d", &N);
  FOR (i, 0, 5) {
    fscanf(fr, "%d%d", &kun[i].x, &kun[i].y);
  }
  FOR (i, 0, 5) {
    fscanf(fr, "%d%d", &cil[i].x, &cil[i].y);
  }
  
  FOR (k, 0, 5) {
    FOR (y, 0, N) FOR (x, 0, N)
      skoky[y][x] = INT_MAX/5;
    // BFS pro k-tého koně 
    queue<Bod> q;
    q.push(kun[k]); skoky[kun[k].y][kun[k].x] = 0;
    while (!q.empty()) {
      Bod b = q.front(); q.pop();
      FOR (i, 0, 8) {
	Bod a = {b.x + smer[i].x, b.y + smer[i].y};
	if (a.x >= 0 && a.x < N && a.y >= 0 && a.y < N && skoky[a.y][a.x]==INT_MAX/5) {
	  q.push((Bod){a.x, a.y});
	  skoky[a.y][a.x] = skoky[b.y][b.x]+1;
	}
      }
    }
    // Vzdálenosti od cílových pozicí
    FOR (i, 0, 5) {
      D[k][i] = skoky[cil[i].y][cil[i].x];
    }
  }
  
  zkus_perm(0);
  if (ret>=INT_MAX/5)
    fprintf(fw, "-1\n");
  else
    fprintf(fw, "%d\n", ret);
  fclose(fr);
  fclose(fw);
  return 0;
}
